apiVersion: v1
kind: Template
labels:
  app: roundcube
  template: roundcube-buildconfig-with-secret
metadata:
  annotations:
    description: Roundcube - BuildConfig with Secret
    iconClass: icon-php
    openshift.io/display-name: Roundcube
    tags: roundcube
  name: roundcube-buildconfig-with-secret
objects:
- apiVersion: v1
  kind: Secret
  metadata:
    annotations:
      template.openshift.io/expose-username: "{.data['username']}"
    name: git-roundcube-${ROUNDCUBE_REPOSITORY_REF}
  stringData:
    username: "${GIT_DEPLOYMENT_TOKEN}"
- apiVersion: v1
  kind: BuildConfig
  metadata:
    annotations:
      description: Builds Roundcube images
    labels:
      name: roundcube-${ROUNDCUBE_REPOSITORY_REF}
    name: roundcube-${ROUNDCUBE_REPOSITORY_REF}
  spec:
    failedBuildsHistoryLimit: 1
    resources:
      limits:
        cpu: 300m
        memory: 2Gi
    source:
      contextDir: /
      git:
        uri: ${ROUNDCUBE_REPOSITORY_URL}
        ref: "${ROUNDCUBE_REPOSITORY_REF}"
      sourceSecret:
        name: git-roundcube-${ROUNDCUBE_REPOSITORY_REF}
      type: Git
    strategy:
      type: Docker
      dockerStrategy:
        env:
        - name: DO_UPGRADE
          value: foo
        forcePull: true
        from:
          kind: ImageStreamTag
          name: ${PHP_IMAGESTREAM_TAG}
    output:
      to:
        kind: ImageStreamTag
        name: roundcube:${ROUNDCUBE_REPOSITORY_REF}
    triggers:
    - type: ConfigChange
    - type: ImageChange
parameters:
- name: GIT_DEPLOYMENT_TOKEN
  description: Git deployment token
  displayName: Git Deployment Token
  required: true
- name: PHP_IMAGESTREAM_TAG
  description: Set this to PHP ImageStream tag serving as base for Roundcube BuildConfig
  displayName: PHP ImageStream Tag
  required: true
  value: php:master
- name: ROUNDCUBE_REPOSITORY_REF
  description: Set this to a branch name, tag or other ref of your repository if you are not using the default branch
  displayName: Git Reference
  required: true
  value: master
- name: ROUNDCUBE_REPOSITORY_URL
  description: The URL of the repository with your roundcube Dockerfile
  displayName: Git Repository URL
  required: true
  value: https://gitlab.com/synacksynack/opsperator/docker-roundcube.git
